commit:     ebd5321aa0f3659ae8d94d78c4fb69ec9e555005
Author:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
AuthorDate: Sat Jul 18 14:49:28 2020 +0000
Commit:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
CommitDate: Sat Jul 18 14:51:37 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ebd5321a

app-pda/libplist: fix broken 2.2.0 release on Gentoo

 - upstream introduced new way of naming the library, breaking
   reverse deps, see
   https://github.com/libimobiledevice/libplist/issues/163 and
   upstream commit 137716df3f197a7184c1fba88fcb30480dafd6e0. No ABI
   change introduced.

Closes: https://bugs.gentoo.org/733082
Closes: https://bugs.gentoo.org/733048
Closes: https://bugs.gentoo.org/733048
Closes: https://bugs.gentoo.org/732910
Closes: https://bugs.gentoo.org/732916
Signed-off-by: Joonas Niilola <juippis <AT> gentoo.org>

 .../files/libplist-2.2.0-pkgconfig-lib.patch       |  10 ++
 app-pda/libplist/libplist-2.2.0-r2.ebuild          | 110 +++++++++++++++++++++
 2 files changed, 120 insertions(+)

diff --git a/app-pda/libplist/files/libplist-2.2.0-pkgconfig-lib.patch 
b/app-pda/libplist/files/libplist-2.2.0-pkgconfig-lib.patch
new file mode 100644
index 00000000000..30ef6779886
--- /dev/null
+++ b/app-pda/libplist/files/libplist-2.2.0-pkgconfig-lib.patch
@@ -0,0 +1,10 @@
+diff -Naur libplist/src/libplist-2.0.pc.in 
libplist-pcfile/src/libplist-2.0.pc.in
+--- libplist/src/libplist-2.0.pc.in    2020-07-18 17:25:52.156222244 +0300
++++ libplist-pcfile/src/libplist-2.0.pc.in     2020-07-18 17:26:32.752017958 
+0300
+@@ -6,5 +6,5 @@
+ Name: @PACKAGE_NAME@
+ Description: A library to handle Apple Property Lists whereas they are binary 
or XML
+ Version: @PACKAGE_VERSION@
+-Libs: -L${libdir} -lplist-2.0
++Libs: -L${libdir} -lplist-2.0 -lplist
+ Cflags: -I${includedir}

diff --git a/app-pda/libplist/libplist-2.2.0-r2.ebuild 
b/app-pda/libplist/libplist-2.2.0-r2.ebuild
new file mode 100644
index 00000000000..d7ac5a7b4a3
--- /dev/null
+++ b/app-pda/libplist/libplist-2.2.0-r2.ebuild
@@ -0,0 +1,110 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{7,8} )
+inherit autotools python-r1 toolchain-funcs
+
+DESCRIPTION="Support library to deal with Apple Property Lists (Binary & XML)"
+HOMEPAGE="https://www.libimobiledevice.org/";
+SRC_URI="https://cgit.libimobiledevice.org/${PN}.git/snapshot/${P}.tar.bz2";
+
+LICENSE="GPL-2 LGPL-2.1"
+SLOT="0/2.0-3"
+KEYWORDS="~amd64 ~arm ~arm64 ~ppc ~ppc64 ~x86"
+IUSE="python static-libs"
+
+RDEPEND="python? ( ${PYTHON_DEPS} )"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       virtual/pkgconfig
+       python? ( >=dev-python/cython-0.17[${PYTHON_USEDEP}] )
+"
+
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+DOCS=( AUTHORS NEWS README.md )
+
+PATCHES=( "${FILESDIR}"/libplist-2.2.0-pkgconfig-lib.patch )
+
+BUILD_DIR="${S}_build"
+
+src_prepare() {
+       default
+       eautoreconf
+}
+
+src_configure() {
+       local ECONF_SOURCE=${S}
+       local myeconfargs=( $(use_enable static-libs static) )
+
+       do_configure() {
+               mkdir -p "${BUILD_DIR}" || die
+               pushd "${BUILD_DIR}" >/dev/null || die
+               econf "${myeconfargs[@]}" "${@}"
+               popd >/dev/null || die
+       }
+
+       do_configure_python() {
+               local -x PYTHON_LDFLAGS="$(python_get_LIBS)"
+               do_configure "$@"
+       }
+
+       # Don't prefer clang.
+       tc-export CC CXX
+
+       do_configure --without-cython
+       use python && python_foreach_impl do_configure_python
+}
+
+src_compile() {
+       #
+       ln -s "${native_builddir}/src/libplist-2.0.la" 
"${native_builddir}/src/libplist.la"
+       python_compile() {
+               emake -C "${BUILD_DIR}"/cython \
+                       VPATH="${S}/cython:${native_builddir}/cython" \
+                       plist_la_LIBADD="${native_builddir}/src/libplist-2.0.la"
+       }
+
+       local native_builddir=${BUILD_DIR}
+       pushd "${BUILD_DIR}" >/dev/null || die
+       emake
+       use python && python_foreach_impl python_compile
+       popd >/dev/null || die
+}
+
+src_test() {
+       emake -C "${BUILD_DIR}" check
+}
+
+src_install() {
+       python_install() {
+               emake -C "${BUILD_DIR}/cython" \
+                       VPATH="${S}/cython:${native_builddir}/cython" \
+                       DESTDIR="${D}" install
+       }
+
+       local native_builddir=${BUILD_DIR}
+       pushd "${BUILD_DIR}" >/dev/null || die
+       emake DESTDIR="${D}" install
+       use python && python_foreach_impl python_install
+       popd >/dev/null || die
+
+       einstalldocs
+
+       if use python ; then
+               insinto /usr/include/plist/cython
+               doins cython/plist.pxd
+       fi
+
+       find "${D}" -name '*.la' -delete || die
+
+       # temporary fix for 2.2.0 release: 
+       # b.g.o 733082, 
+       # https://github.com/libimobiledevice/libplist/issues/163
+       # upstream commit 137716df3f197a7184c1fba88fcb30480dafd6e0
+       dosym ./libplist-2.0.pc /usr/$(get_libdir)/pkgconfig/libplist.pc
+       dosym ./libplist++-2.0.so.3.3.0 /usr/$(get_libdir)/libplist++.so
+       dosym ./libplist-2.0.so.3.3.0 /usr/$(get_libdir)/libplist.so
+}

Reply via email to